// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/driver/16hsdi4ao4.h $
// $Rev: 53435 $
// $Date: 2023-07-24 10:01:26 -0500 (Mon, 24 Jul 2023) $

// 16HSDI4AO4: Device Driver: header file

#ifndef	__16HSDI4AO4_H__
#define	__16HSDI4AO4_H__

#include "gsc_common.h"
#include "gsc_pci9056.h"



// macros *********************************************************************

#define	HSDI4AO4_BASE_NAME					"16hsdi4ao4"
#define	HSDI4AO4_BASE_NAME_LC				HSDI4AO4_BASE_NAME
#define	HSDI4AO4_BASE_NAME_UC				"HSDI4AO4"

// IOCTL command codes
#define	HSDI4AO4_IOCTL_REG_READ				OS_IOCTL_RW( 0, 12, gsc_reg_t)
#define	HSDI4AO4_IOCTL_REG_WRITE			OS_IOCTL_W ( 1, 12, gsc_reg_t)
#define	HSDI4AO4_IOCTL_REG_MOD				OS_IOCTL_W ( 2, 12, gsc_reg_t)
#define	HSDI4AO4_IOCTL_QUERY				OS_IOCTL_RW( 3,  4, s32)
#define	HSDI4AO4_IOCTL_INITIALIZE			OS_IOCTL   ( 4)
#define	HSDI4AO4_IOCTL_AUTOCAL				OS_IOCTL   ( 5)
#define	HSDI4AO4_IOCTL_AUTOCAL_STATUS		OS_IOCTL_R ( 6,  4, s32)
#define	HSDI4AO4_IOCTL_RX_IO_ABORT			OS_IOCTL_R ( 7,  4, s32)
#define	HSDI4AO4_IOCTL_RX_IO_MODE			OS_IOCTL_RW( 8,  4, s32)
#define	HSDI4AO4_IOCTL_RX_IO_OVERFLOW		OS_IOCTL_RW( 9,  4, s32)
#define	HSDI4AO4_IOCTL_RX_IO_TIMEOUT		OS_IOCTL_RW(10,  4, s32)
#define	HSDI4AO4_IOCTL_RX_IO_UNDERFLOW		OS_IOCTL_RW(11,  4, s32)
#define	HSDI4AO4_IOCTL_TX_IO_ABORT			OS_IOCTL_R (12,  4, s32)
#define	HSDI4AO4_IOCTL_TX_IO_MODE			OS_IOCTL_RW(13,  4, s32)
#define	HSDI4AO4_IOCTL_TX_IO_OVERFLOW		OS_IOCTL_RW(14,  4, s32)
#define	HSDI4AO4_IOCTL_TX_IO_TIMEOUT		OS_IOCTL_RW(15,  4, s32)
#define	HSDI4AO4_IOCTL_AI_BUF_CLEAR			OS_IOCTL   (16)
#define	HSDI4AO4_IOCTL_AI_BUF_LEVEL			OS_IOCTL_R (17,  4, s32)
#define	HSDI4AO4_IOCTL_AI_BUF_OVERFLOW		OS_IOCTL_RW(18,  4, s32)
#define	HSDI4AO4_IOCTL_AI_BUF_THR_LVL		OS_IOCTL_RW(19,  4, s32)
#define	HSDI4AO4_IOCTL_AI_BUF_THR_STS		OS_IOCTL_RW(20,  4, s32)
#define	HSDI4AO4_IOCTL_AI_BUF_UNDERFLOW		OS_IOCTL_RW(21,  4, s32)
#define	HSDI4AO4_IOCTL_AI_BURST_ENABLE		OS_IOCTL_RW(22,  4, s32)
#define	HSDI4AO4_IOCTL_AI_BURST_SIZE		OS_IOCTL_RW(23,  4, s32)
#define	HSDI4AO4_IOCTL_AI_BURST_STATUS		OS_IOCTL_R (24,  4, s32)
#define	HSDI4AO4_IOCTL_AI_CHAN_SEL			OS_IOCTL_RW(25,  4, s32)
#define	HSDI4AO4_IOCTL_AI_CLOCK_MODE		OS_IOCTL_RW(26,  4, s32)
#define	HSDI4AO4_IOCTL_AI_ENABLE			OS_IOCTL_RW(27,  4, s32)
#define	HSDI4AO4_IOCTL_AI_MODE				OS_IOCTL_RW(28,  4, s32)
#define	HSDI4AO4_IOCTL_AI_RANGE				OS_IOCTL_RW(29,  4, s32)
#define	HSDI4AO4_IOCTL_AI_SW_CLOCK			OS_IOCTL   (30)
#define	HSDI4AO4_IOCTL_AI_SW_TRIGGER		OS_IOCTL   (31)
#define	HSDI4AO4_IOCTL_AO_BUF_CLEAR			OS_IOCTL   (32)
#define	HSDI4AO4_IOCTL_AO_BUF_EMPTY			OS_IOCTL_R (33,  4, s32)
#define	HSDI4AO4_IOCTL_AO_BUF_LEVEL			OS_IOCTL_R (34,  4, s32)
#define	HSDI4AO4_IOCTL_AO_BUF_LOAD_REQ		OS_IOCTL   (35)
#define	HSDI4AO4_IOCTL_AO_BUF_LOAD_STS		OS_IOCTL_R (36,  4, s32)
#define	HSDI4AO4_IOCTL_AO_BUF_MODE			OS_IOCTL_RW(37,  4, s32)
#define	HSDI4AO4_IOCTL_AO_BUF_OVER_DATA		OS_IOCTL_RW(38,  4, s32)
#define	HSDI4AO4_IOCTL_AO_BUF_OVER_FRAM		OS_IOCTL_RW(39,  4, s32)
#define	HSDI4AO4_IOCTL_AO_BUF_THR_LVL		OS_IOCTL_RW(40,  4, s32)
#define	HSDI4AO4_IOCTL_AO_BUF_THR_STS		OS_IOCTL_R (41,  4, s32)
#define	HSDI4AO4_IOCTL_AO_BURST_ENABLE		OS_IOCTL_RW(42,  4, s32)
#define	HSDI4AO4_IOCTL_AO_BURST_STATUS		OS_IOCTL_R (43,  4, s32)
#define	HSDI4AO4_IOCTL_AO_CHAN_SEL			OS_IOCTL_RW(44,  4, s32)
#define	HSDI4AO4_IOCTL_AO_CLOCK_MODE		OS_IOCTL_RW(45,  4, s32)
#define	HSDI4AO4_IOCTL_AO_CLOCK_STATUS		OS_IOCTL_R (46,  4, s32)
#define	HSDI4AO4_IOCTL_AO_ENABLE			OS_IOCTL_RW(47,  4, s32)
#define	HSDI4AO4_IOCTL_AO_MODE				OS_IOCTL_RW(48,  4, s32)
#define	HSDI4AO4_IOCTL_AO_OUTPUT_MODE		OS_IOCTL_RW(49,  4, s32)
#define	HSDI4AO4_IOCTL_AO_RANGE				OS_IOCTL_RW(50,  4, s32)
#define	HSDI4AO4_IOCTL_AO_SW_CLOCK			OS_IOCTL   (51)
#define	HSDI4AO4_IOCTL_AO_SW_TRIGGER		OS_IOCTL   (52)
#define	HSDI4AO4_IOCTL_AO_SYNC_MODE			OS_IOCTL_RW(53,  4, s32)
#define	HSDI4AO4_IOCTL_DATA_FORMAT			OS_IOCTL_RW(54,  4, s32)
#define	HSDI4AO4_IOCTL_DIO_DIR_OUT			OS_IOCTL_RW(55,  4, s32)
#define	HSDI4AO4_IOCTL_DIO_READ				OS_IOCTL_RW(56,  4, s32)
#define	HSDI4AO4_IOCTL_DIO_WRITE			OS_IOCTL_RW(57,  4, s32)
#define	HSDI4AO4_IOCTL_GEN_A_ENABLE			OS_IOCTL_RW(58,  4, s32)
#define	HSDI4AO4_IOCTL_GEN_A_NDIV			OS_IOCTL_RW(59,  4, s32)
#define	HSDI4AO4_IOCTL_GEN_A_NREF			OS_IOCTL_RW(60,  4, s32)
#define	HSDI4AO4_IOCTL_GEN_A_NVCO			OS_IOCTL_RW(61,  4, s32)
#define	HSDI4AO4_IOCTL_GEN_B_ENABLE			OS_IOCTL_RW(62,  4, s32)
#define	HSDI4AO4_IOCTL_GEN_B_NDIV			OS_IOCTL_RW(63,  4, s32)
#define	HSDI4AO4_IOCTL_GEN_C_ENABLE			OS_IOCTL_RW(64,  4, s32)
#define	HSDI4AO4_IOCTL_GEN_C_NDIV			OS_IOCTL_RW(65,  4, s32)
#define	HSDI4AO4_IOCTL_IRQ_ENABLE			OS_IOCTL_RW(66,  4, s32)
#define	HSDI4AO4_IOCTL_MASTER_CLOCK			OS_IOCTL_RW(67,  4, s32)
#define	HSDI4AO4_IOCTL_MASTER_CLOCK_ADJ		OS_IOCTL_RW(68,  4, s32)
#define	HSDI4AO4_IOCTL_TRIGGER_MODE			OS_IOCTL_RW(69,  4, s32)
#define	HSDI4AO4_IOCTL_WAIT_EVENT			OS_IOCTL_RW(70, 28, gsc_wait_t)
#define	HSDI4AO4_IOCTL_WAIT_CANCEL			OS_IOCTL_RW(71, 28, gsc_wait_t)
#define	HSDI4AO4_IOCTL_WAIT_STATUS			OS_IOCTL_RW(72, 28, gsc_wait_t)

//*****************************************************************************
// HSDI4AO4_IOCTL_REG_READ
// HSDI4AO4_IOCTL_REG_WRITE
// HSDI4AO4_IOCTL_REG_MOD
//
#define	HSDI4AO4_REG_ENCODE(s,o)			GSC_REG_ENCODE(GSC_REG_TYPE_BAR2,(s),(o))
// Parameter:	gsc_reg_t*
#define	HSDI4AO4_GSC_BCR					HSDI4AO4_REG_ENCODE(4,0x00)// Board Control Register
#define	HSDI4AO4_GSC_DIOPR					HSDI4AO4_REG_ENCODE(4,0x04)// Digital I/O Port Register
#define	HSDI4AO4_GSC_AOC0R					HSDI4AO4_REG_ENCODE(4,0x08)// Anlog Output Channel 0 Register
#define	HSDI4AO4_GSC_AOC1R					HSDI4AO4_REG_ENCODE(4,0x0C)// Anlog Output Channel 1 Register
#define	HSDI4AO4_GSC_AOC2R					HSDI4AO4_REG_ENCODE(4,0x10)// Anlog Output Channel 2 Register
#define	HSDI4AO4_GSC_AOC3R					HSDI4AO4_REG_ENCODE(4,0x14)// Anlog Output Channel 3 Register
#define	HSDI4AO4_GSC_AIBR					HSDI4AO4_REG_ENCODE(4,0x18)// Analog Input Buffer Register
#define	HSDI4AO4_GSC_RGAR					HSDI4AO4_REG_ENCODE(4,0x1C)// Rate Generator A Register
#define	HSDI4AO4_GSC_RGBR					HSDI4AO4_REG_ENCODE(4,0x20)// Rate Generator B Register
#define	HSDI4AO4_GSC_ICR					HSDI4AO4_REG_ENCODE(4,0x24)// Input Configuration Register
#define	HSDI4AO4_GSC_IBSR					HSDI4AO4_REG_ENCODE(4,0x28)// Input Buffer Size Register
#define	HSDI4AO4_GSC_IBTR					HSDI4AO4_REG_ENCODE(4,0x2C)// Input Buffer Threshold Register
#define	HSDI4AO4_GSC_PSR					HSDI4AO4_REG_ENCODE(4,0x30)// Primary Status Register
#define	HSDI4AO4_GSC_ACR					HSDI4AO4_REG_ENCODE(4,0x34)// Assymbly Configuration Register
#define	HSDI4AO4_GSC_AVR					HSDI4AO4_REG_ENCODE(4,0x38)// Autocal Values Register
#define	HSDI4AO4_GSC_BOOR					HSDI4AO4_REG_ENCODE(4,0x3C)// Buffered Output Operations Register
#define	HSDI4AO4_GSC_OBTR					HSDI4AO4_REG_ENCODE(4,0x40)// Output Buffer Threshold Register
#define	HSDI4AO4_GSC_OBSR					HSDI4AO4_REG_ENCODE(4,0x44)// Output Buffer Size Register
#define	HSDI4AO4_GSC_AOBR					HSDI4AO4_REG_ENCODE(4,0x48)// Analog Output Buffer Register
#define	HSDI4AO4_GSC_RGCR					HSDI4AO4_REG_ENCODE(4,0x4C)// Rate Generator C Register
#define	HSDI4AO4_GSC_MCAR					HSDI4AO4_REG_ENCODE(4,0x60)// Master Clock Adjust Register

//*****************************************************************************
// HSDI4AO4_IOCTL_QUERY
//
//	Parameter:	s32
//		Pass in a value from the list below.
//		The value returned is the answer to the query.

typedef enum
{
	HSDI4AO4_QUERY_AUTOCAL_MS,			// Max autocalibrate period in ms.
	HSDI4AO4_QUERY_CHANNEL_AI_MAX,		// Maximum number of input channels supported.
	HSDI4AO4_QUERY_CHANNEL_AI_QTY,		// The number of input channels supported.
	HSDI4AO4_QUERY_CHANNEL_AO_MAX,		// Maximum number of output channels supported.
	HSDI4AO4_QUERY_CHANNEL_AO_QTY,		// The number of output channels supported.
	HSDI4AO4_QUERY_COUNT,				// How many query options are supported?
	HSDI4AO4_QUERY_DEVICE_TYPE,			// Value from gsc_dev_type_t
	HSDI4AO4_QUERY_FIFO_SIZE_RX,		// Rx FIFO depth in 32-bit samples
	HSDI4AO4_QUERY_FIFO_SIZE_TX,		// Tx FIFO depth in 32-bit samples
	HSDI4AO4_QUERY_FSAMP_MAX,			// The maximum sample rate per channel.
	HSDI4AO4_QUERY_FSAMP_MIN,			// The minimum sample rate per channel.
	HSDI4AO4_QUERY_INIT_MS,				// Max initialize period in ms.
	HSDI4AO4_QUERY_MASTER_CLOCK_DEF,	// Default master clock frequency
	HSDI4AO4_QUERY_MCAR,				// Is this register available?
	HSDI4AO4_QUERY_GEN_A_NDIV_MAX,		// Rate-A Generator Ndiv maximum
	HSDI4AO4_QUERY_GEN_A_NDIV_MIN,		// Rate-A Generator Ndiv minimum
	HSDI4AO4_QUERY_GEN_A_NREF_MAX,		// Rate-A Generator Nref maximum
	HSDI4AO4_QUERY_GEN_A_NREF_MIN,		// Rate-A Generator Nref minimum
	HSDI4AO4_QUERY_GEN_A_NVCO_MAX,		// Rate-A Generator Nvco maximum
	HSDI4AO4_QUERY_GEN_A_NVCO_MIN,		// Rate-A Generator Nvco minimum
	HSDI4AO4_QUERY_GEN_B_NDIV_MAX,		// Rate-B Generator Ndiv maximum
	HSDI4AO4_QUERY_GEN_B_NDIV_MIN,		// Rate-B Generator Ndiv minimum
	HSDI4AO4_QUERY_GEN_C_NDIV_MAX,		// Rate-C Generator Ndiv maximum
	HSDI4AO4_QUERY_GEN_C_NDIV_MIN,		// Rate-C Generator Ndiv minimum
	HSDI4AO4_QUERY_GEN_A_MAX,			// Rate-A Generator maximum
	HSDI4AO4_QUERY_GEN_A_MIN,			// Rate-A Generator minimum

	HSDI4AO4_IOCTL_QUERY_LAST

} hsdi4ao4_query_t;

#define	HSDI4AO4_IOCTL_QUERY_ERROR			(-1)

//*****************************************************************************
// HSDI4AO4_IOCTL_INITIALIZE				BCR D31
//
//	Parameter:	None

//*****************************************************************************
// HSDI4AO4_IOCTL_AUTOCAL					BCR D28
//
//	Parameter:	None

// Retained for backwards compatibility only:
#define	HSDI4AO4_IOCTL_AUTO_CALIBRATE		HSDI4AO4_IOCTL_AUTOCAL

//*****************************************************************************
// HSDI4AO4_IOCTL_AUTOCAL_STATUS			BCR D29
//
//	Parameter:	s32*
//		One of the below values is returned.
#define	HSDI4AO4_AUTOCAL_STATUS_ACTIVE		0
#define	HSDI4AO4_AUTOCAL_STATUS_FAIL		1
#define	HSDI4AO4_AUTOCAL_STATUS_PASS		2

// Retained for backwards compatibility only:
#define	HSDI4AO4_IOCTL_AUTO_CAL_STS			HSDI4AO4_IOCTL_AUTOCAL_STATUS
#define	HSDI4AO4_AUTO_CAL_STS_ACTIVE		HSDI4AO4_AUTOCAL_STATUS_ACTIVE
#define	HSDI4AO4_AUTO_CAL_STS_FAIL			HSDI4AO4_AUTOCAL_STATUS_FAIL
#define	HSDI4AO4_AUTO_CAL_STS_PASS			HSDI4AO4_AUTOCAL_STATUS_PASS

//*****************************************************************************
// HSDI4AO4_IOCTL_RX_IO_ABORT
// HSDI4AO4_IOCTL_TX_IO_ABORT
//
//	Parameter:	s32*
//		The returned value is one of the below options.
#define	HSDI4AO4_IO_ABORT_NO				0
#define	HSDI4AO4_IO_ABORT_YES				1

//*****************************************************************************
// HSDI4AO4_IOCTL_RX_IO_MODE
// HSDI4AO4_IOCTL_TX_IO_MODE
//
//	Parameter:	s32*
//		Pass in any of the gsc_io_mode_t options, or
//		-1 to read the current setting.
#define	HSDI4AO4_IO_MODE_DEFAULT			GSC_IO_MODE_PIO

//*****************************************************************************
// HSDI4AO4_IOCTL_RX_IO_OVERFLOW
// HSDI4AO4_IOCTL_TX_IO_OVERFLOW
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_IO_OVERFLOW_DEFAULT		HSDI4AO4_IO_OVERFLOW_CHECK
#define	HSDI4AO4_IO_OVERFLOW_IGNORE			0
#define	HSDI4AO4_IO_OVERFLOW_CHECK			1

//*****************************************************************************
// HSDI4AO4_IOCTL_RX_IO_TIMEOUT (in seconds)
// HSDI4AO4_IOCTL_TX_IO_TIMEOUT (in seconds)
//
//	Parameter:	s32*
//		Pass in any value from the minimim to the maximim, the infinite option,
//		or -1 to read the current setting. The value -1 is returned if the
//		feature is not supported, but this should never happen.
#define	HSDI4AO4_IO_TIMEOUT_DEFAULT			10
#define	HSDI4AO4_IO_TIMEOUT_NO_SLEEP		0
#define	HSDI4AO4_IO_TIMEOUT_MIN				0
#define	HSDI4AO4_IO_TIMEOUT_MAX				GSC_IO_TIMEOUT_MAX
#define	HSDI4AO4_IO_TIMEOUT_INFINITE		GSC_IO_TIMEOUT_INFINITE

//*****************************************************************************
// HSDI4AO4_IOCTL_RX_IO_UNDERFLOW
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_IO_UNDERFLOW_DEFAULT		HSDI4AO4_IO_UNDERFLOW_CHECK
#define	HSDI4AO4_IO_UNDERFLOW_IGNORE		0
#define	HSDI4AO4_IO_UNDERFLOW_CHECK			1

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_BUF_CLEAR				BCR D13
// HSDI4AO4_IOCTL_AO_BUF_CLEAR				BOOR D11
//
//	Parameter:	None.

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_BUF_LEVEL				IBSR D0-D18
// HSDI4AO4_IOCTL_AO_BUF_LEVEL				OBSR D0-D18
//
//	Parameter:	s32*
//		The value returned is the current buffer fill level.

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_BUF_OVERFLOW			BCR D15
// HSDI4AO4_IOCTL_AO_BUF_OVER_DATA			BOOR D16
// HSDI4AO4_IOCTL_AO_BUF_OVER_FRAM			BOOR D17
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	HSDI4AO4_BUF_OVERFLOW_CLEAR			0
#define	HSDI4AO4_BUF_OVERFLOW_TEST			(-1)

// For queries the following values are returned.
#define	HSDI4AO4_BUF_OVERFLOW_NO			0
#define	HSDI4AO4_BUF_OVERFLOW_YES			1

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_BUF_THR_LVL			IBTR D0-D18
// HSDI4AO4_IOCTL_AO_BUF_THR_LVL			OBTR D0-D18
//
//	Parameter:	s32*
//		Pass in any valid value from 0x0 to 0x7FFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_BUF_THR_STS			IBTR D19
// HSDI4AO4_IOCTL_AO_BUF_THR_STS			OBTR D19
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	HSDI4AO4_BUF_THR_STS_CLEAR			0
#define	HSDI4AO4_BUF_THR_STS_SET			1

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_BUF_UNDERFLOW			BCR D23
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_BUF_UNDERFLOW_CLEAR		0
#define	HSDI4AO4_BUF_UNDERFLOW_TEST			(-1)

// For queries the following values are returned.
#define	HSDI4AO4_BUF_UNDERFLOW_NO			0
#define	HSDI4AO4_BUF_UNDERFLOW_YES			1

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_BURST_ENABLE			BCR D9
// HSDI4AO4_IOCTL_AO_BURST_ENABLE			BOOR D19
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	HSDI4AO4_BURST_ENABLE_NO			0
#define	HSDI4AO4_BURST_ENABLE_YES			1

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_BURST_SIZE				ICR D0-D23
//
//	Parameter:	s32*
//		Pass in any value between the below inclusive limits, or
//		-1 to read the current setting.
//		At this time the valid range is 0-0xFFFFFF.

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_BURST_STATUS			BCR D10
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	HSDI4AO4_AI_BURST_STATUS_READY		0
#define	HSDI4AO4_AI_BURST_STATUS_BUSY		1

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_CHAN_SEL				ICR D24-D27
// HSDI4AO4_IOCTL_AO_CHAN_SEL				BOOR D0-D3
//
//	Parameter:	s32*
//		Pass in a bitmap of the channels to enable, or
//		-1 to read the current setting.
//		A valid bitmap is dependent on the AI or AO selection and the
//		number of corresponding input or output channels on the device.

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_CLOCK_MODE				BCR D24
// HSDI4AO4_IOCTL_AO_CLOCK_MODE				BOOR D4
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_CLOCK_MODE_IN				0
#define	HSDI4AO4_CLOCK_MODE_OUT				1

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_ENABLE					BCR D12
// HSDI4AO4_IOCTL_AO_ENABLE					BOOR D5
//
//	Parameter:	s32*
//		Pass in any valid option below, or
//		-1 to read the current setting.
#define	HSDI4AO4_AIO_ENABLE_NO				0	// Disable the buffer.
#define	HSDI4AO4_AIO_ENABLE_YES				1	// Enable the buffer.

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_MODE					BCR D0-D2
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_AI_MODE_DIFF				0	// Differential
#define	HSDI4AO4_AI_MODE_SINGLE				1	// Single-Ended
#define	HSDI4AO4_AI_MODE_ZERO				2	// Zero test
#define	HSDI4AO4_AI_MODE_VREF				3	// Vref test
#define	HSDI4AO4_AI_MODE_AO_0				4	// Analog Output Channel 0
#define	HSDI4AO4_AI_MODE_AO_1				5	// Analog Output Channel 1
#define	HSDI4AO4_AI_MODE_AO_2				6	// Analog Output Channel 2
#define	HSDI4AO4_AI_MODE_AO_3				7	// Analog Output Channel 3

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_RANGE					BCR D4-D5
// HSDI4AO4_IOCTL_AO_RANGE					BCR D16-D17
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_RANGE_2_5V					0	// +- 2.5 volts
#define	HSDI4AO4_RANGE_5V					1	// +- 5 volts
#define	HSDI4AO4_RANGE_10V					2	// +- 10 volts

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_SW_CLOCK				BCR D8
// HSDI4AO4_IOCTL_AO_SW_CLOCK				BCR D20
//
//	Parameter:	None.

//*****************************************************************************
// HSDI4AO4_IOCTL_AI_SW_TRIGGER				BCR D11
// HSDI4AO4_IOCTL_AO_SW_TRIGGER				BOOR D20
//
//	Parameter:	None.

//*****************************************************************************
// HSDI4AO4_IOCTL_AO_BUF_EMPTY				BOOR D12
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	HSDI4AO4_AO_BUFFER_NOT_EMPTY		0
#define	HSDI4AO4_AO_BUFFER_EMPTY			1

//*****************************************************************************
// HSDI4AO4_IOCTL_AO_BUF_LOAD_REQ			BOOR D9
//
//	Parameter:	None.

//*****************************************************************************
// HSDI4AO4_IOCTL_AO_BUF_LOAD_STS			BOOR D10
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	HSDI4AO4_BUF_LOAD_STS_NOT_READY		0
#define	HSDI4AO4_BUF_LOAD_STS_READY			1

//*****************************************************************************
// HSDI4AO4_IOCTL_AO_BUF_MODE				BOOR D8
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_BUF_MODE_OPEN				0
#define	HSDI4AO4_BUF_MODE_CIRC				1

//*****************************************************************************
// HSDI4AO4_IOCTL_AO_BURST_STATUS			BOOR D18
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	HSDI4AO4_AO_BURST_STATUS_BUSY		0
#define	HSDI4AO4_AO_BURST_STATUS_READY		1

//*****************************************************************************
// HSDI4AO4_IOCTL_AO_CLOCK_STATUS			BOOR D6
//
//	Parameter:	s32*
//		The value returned is one of the following.
#define	HSDI4AO4_CLOCK_STATUS_NOT_READY		0
#define	HSDI4AO4_CLOCK_STATUS_READY			1

//*****************************************************************************
// HSDI4AO4_IOCTL_AO_MODE					BCR D19
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_AO_MODE_REG				0
#define	HSDI4AO4_AO_MODE_FIFO				1

//*****************************************************************************
// HSDI4AO4_IOCTL_AO_OUTPUT_MODE			BCR D18
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_AO_OUTPUT_MODE_IMMED		0
#define	HSDI4AO4_AO_OUTPUT_MODE_SIMUL		1

//*****************************************************************************
// HSDI4AO4_IOCTL_AO_SYNC_MODE				BOOR D21-D22
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_AO_SYNC_MODE_IND			0
#define	HSDI4AO4_AO_SYNC_MODE_AI_SAMP		1
#define	HSDI4AO4_AO_SYNC_MODE_AI_ACQ		2

//*****************************************************************************
// HSDI4AO4_IOCTL_DATA_FORMAT				BCR D25
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_DATA_FORMAT_2S_COMP		0	// Twos Compliment
#define	HSDI4AO4_DATA_FORMAT_OFF_BIN		1	// Offset Binary

//*****************************************************************************
// HSDI4AO4_IOCTL_DIO_DIR_OUT				DIOPR D8, D24
//
//	Parameter:	s32*
//		Pass in any value between the range of 0 to 0x3, or
//		-1 to read the current setting.
#define	HSDI4AO4_DIO_DIR_OUT_B0_IN_B1_IN	0  // default state
#define	HSDI4AO4_DIO_DIR_OUT_B0_OT_B1_IN	1
#define	HSDI4AO4_DIO_DIR_OUT_B0_IN_B1_OT	2
#define	HSDI4AO4_DIO_DIR_OUT_B0_OT_B1_OT	3

//*****************************************************************************
// HSDI4AO4_IOCTL_DIO_READ					DIOPR D0-D7, D16-D23
//
//	Parameter:	s32*
//		The value returned is in the range of 0 to 0xFFFF.

//*****************************************************************************
// HSDI4AO4_IOCTL_DIO_WRITE					DIOPR D0-D7, D16-D23
//
//	Parameter:	s32*
//		Pass in any value in the range of 0 to 0xFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// HSDI4AO4_IOCTL_GEN_A_ENABLE				BCR D26
// HSDI4AO4_IOCTL_GEN_B_ENABLE				BCR D27
// HSDI4AO4_IOCTL_GEN_C_ENABLE				BCR D22
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_GEN_ENABLE_NO				0
#define	HSDI4AO4_GEN_ENABLE_YES				1

//*****************************************************************************
// HSDI4AO4_IOCTL_GEN_A_NDIV				RGAR D24-D28
//
//	Parameter:	s32*
//		Pass in any value in the range of 0 to 20, or
//		-1 to read the current setting.

//*****************************************************************************
// HSDI4AO4_IOCTL_GEN_A_NREF				RGAR D12-D21
// HSDI4AO4_IOCTL_GEN_A_NVCO				RGAR D0-D9
//
//	Parameter:	s32*
//		Pass in any value in the range of 30 to 1000, or
//		-1 to read the current setting.

//*****************************************************************************
// HSDI4AO4_IOCTL_GEN_B_NDIV				RGBR D0-D23
// HSDI4AO4_IOCTL_GEN_C_NDIV				RGCR D0-D23
//
//	Parameter:	s32*
//		Pass in any value in the range of 40 to 0xFFFFFF, or
//		-1 to read the current setting.

//*****************************************************************************
// HSDI4AO4_IOCTL_IRQ_ENABLE				PSR D0-D14
//
//	Parameter:	s32*
//		Pass in any combination of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_IRQ_AUTOCAL_DONE			0x0001
#define	HSDI4AO4_IRQ_AI_THRESH_H2L			0x0002
#define	HSDI4AO4_IRQ_AI_THRESH_L2H			0x0004
#define	HSDI4AO4_IRQ_AI_FAULT				0x0008
#define	HSDI4AO4_IRQ_AI_BURST_START			0x0010
#define	HSDI4AO4_IRQ_AI_BURST_DONE			0x0020
#define	HSDI4AO4_IRQ_AI_CLOCK				0x0040
#define	HSDI4AO4_IRQ_AO_CLOCK				0x0080
#define	HSDI4AO4_IRQ_DIO_0_L2H				0x0100
#define	HSDI4AO4_IRQ_AO_THRESH_H2L			0x0200
#define	HSDI4AO4_IRQ_AO_THRESH_L2H			0x0400
#define	HSDI4AO4_IRQ_AO_LOAD_RDY_H2L		0x0800
#define	HSDI4AO4_IRQ_AO_LOAD_RDY_L2H		0x1000
#define	HSDI4AO4_IRQ_AO_BURST_READY			0x2000
#define	HSDI4AO4_IRQ_AO_FAULT				0x4000
#define	HSDI4AO4_IRQ_ALL					0x7FFF

// Retained for backwards compatibility only:
#define	HSDI4AO4_IRQ_AUTO_CAL_DONE			HSDI4AO4_IRQ_AUTOCAL_DONE

//*****************************************************************************
// HSDI4AO4_IOCTL_MASTER_CLOCK
//
//	Parameter:	s32*
//		Pass in any value in the below inclusive range, or
//		-1 to read the current setting.
#define	HSDI4AO4_MASTER_CLOCK_MIN			30000000L
#define	HSDI4AO4_MASTER_CLOCK_MAX			47000000L

//*****************************************************************************
// HSDI4AO4_IOCTL_MASTER_CLOCK_ADJ			MCAR D0_D15
//
//	Parameter:	s32*
//		Pass in any value in the below inclusive range, or
//		-1 to read the current setting.
#define	HSDI4AO4_MASTER_CLOCK_ADJ_MIN		0x0000
#define	HSDI4AO4_MASTER_CLOCK_ADJ_MAX		0xFFFF

//*****************************************************************************
// HSDI4AO4_IOCTL_TRIGGER_MODE				BCR D21
//
//	Parameter:	s32*
//		Pass in any of the below options, or
//		-1 to read the current setting.
#define	HSDI4AO4_TRIGGER_MODE_IN			0
#define	HSDI4AO4_TRIGGER_MODE_OUT			1

//*****************************************************************************
// HSDI4AO4_IOCTL_WAIT_EVENT				all fields must be valid
// HSDI4AO4_IOCTL_WAIT_CANCEL				fields need not be valid
// HSDI4AO4_IOCTL_WAIT_STATUS				fields need not be valid
//
//	Parameter:	gsc_wait_t*
// gsc_wait_t.flags - see gsc_common.h
// gsc_wait_t.main - see gsc_common.h
// gsc_wait_t.gsc
#define	HSDI4AO4_WAIT_GSC_AUTOCAL_DONE		HSDI4AO4_IRQ_AUTOCAL_DONE
#define	HSDI4AO4_WAIT_GSC_AI_THRESH_H2L		HSDI4AO4_IRQ_AI_THRESH_H2L
#define	HSDI4AO4_WAIT_GSC_AI_THRESH_L2H		HSDI4AO4_IRQ_AI_THRESH_L2H
#define	HSDI4AO4_WAIT_GSC_AI_FAULT			HSDI4AO4_IRQ_AI_FAULT
#define	HSDI4AO4_WAIT_GSC_AI_BURST_START	HSDI4AO4_IRQ_AI_BURST_START
#define	HSDI4AO4_WAIT_GSC_AI_BURST_DONE		HSDI4AO4_IRQ_AI_BURST_DONE
#define	HSDI4AO4_WAIT_GSC_AI_CLOCK			HSDI4AO4_IRQ_AI_CLOCK
#define	HSDI4AO4_WAIT_GSC_AO_CLOCK			HSDI4AO4_IRQ_AO_CLOCK
#define	HSDI4AO4_WAIT_GSC_DIO_0_L2H			HSDI4AO4_IRQ_DIO_0_L2H
#define	HSDI4AO4_WAIT_GSC_AO_THRESH_H2L		HSDI4AO4_IRQ_AO_THRESH_H2L
#define	HSDI4AO4_WAIT_GSC_AO_THRESH_L2H		HSDI4AO4_IRQ_AO_THRESH_L2H
#define	HSDI4AO4_WAIT_GSC_AO_LOAD_RDY_HL	HSDI4AO4_IRQ_AO_LOAD_RDY_H2L
#define	HSDI4AO4_WAIT_GSC_AO_LOAD_RDY_LH	HSDI4AO4_IRQ_AO_LOAD_RDY_L2H
#define	HSDI4AO4_WAIT_GSC_AO_BURST_READY	HSDI4AO4_IRQ_AO_BURST_READY
#define	HSDI4AO4_WAIT_GSC_AO_FAULT			HSDI4AO4_IRQ_AO_FAULT
#define	HSDI4AO4_WAIT_GSC_ALL				HSDI4AO4_IRQ_ALL
// gsc_wait_t.alt flags
#define	HSDI4AO4_WAIT_ALT_ALL				0x0000
// gsc_wait_t.io
#define	HSDI4AO4_WAIT_IO_RX_ABORT			0x0001
#define	HSDI4AO4_WAIT_IO_RX_DONE			0x0002
#define	HSDI4AO4_WAIT_IO_RX_ERROR			0x0004
#define	HSDI4AO4_WAIT_IO_RX_TIMEOUT			0x0008
#define	HSDI4AO4_WAIT_IO_TX_ABORT			0x0010
#define	HSDI4AO4_WAIT_IO_TX_DONE			0x0020
#define	HSDI4AO4_WAIT_IO_TX_ERROR			0x0040
#define	HSDI4AO4_WAIT_IO_TX_TIMEOUT			0x0080
#define	HSDI4AO4_WAIT_IO_ALL				0x00FF

// Retained for backwards compatibility only:
#define	HSDI4AO4_WAIT_GSC_AUTO_CAL_DONE		HSDI4AO4_IRQ_AUTOCAL_DONE



#endif
