// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/driver/irq.c $
// $Rev: 49708 $
// $Date: 2021-10-01 17:04:03 -0500 (Fri, 01 Oct 2021) $

// 16HSDI4AO4: Device Driver: source file

#include "main.h"



//*****************************************************************************
void dev_irq_isr_local_handler(dev_data_t* dev)
{
	u32	mask;
	u32	psr;

	psr		= os_reg_mem_rx_u32(NULL, dev->vaddr.gsc_psr_32);
	mask	= psr & (psr >> 16) & 0xFFFF;

	if (mask)
	{
		psr	= (psr & 0xFFFF) | ((mask << 16) ^ 0xFFFF0000);
		os_reg_mem_tx_u32(NULL, dev->vaddr.gsc_psr_32, psr);
		gsc_wait_resume_irq_gsc(dev, mask);
	}
	else
	{
		// We don't know the source of the interrupt.
		gsc_wait_resume_irq_main(dev, GSC_WAIT_MAIN_SPURIOUS);
	}
}



//*****************************************************************************
int dev_irq_create(dev_data_t* dev)
{
	int	ret;

	os_reg_mem_tx_u32(dev, dev->vaddr.gsc_psr_32, 0);
	ret	= gsc_irq_create(dev);
	return(ret);
}



//*****************************************************************************
void dev_irq_destroy(dev_data_t* dev)
{
	if (dev->vaddr.gsc_psr_32)
		os_reg_mem_tx_u32(dev, dev->vaddr.gsc_psr_32, 0);

	gsc_irq_destroy(dev);
}


