// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/include/16hsdi4ao4_utils.h $
// $Rev: 53415 $
// $Date: 2023-07-20 12:39:14 -0500 (Thu, 20 Jul 2023) $

// 16HSDI4AO4: Utilities: header file

#ifndef	__16HSDI4AO4_UTILS_H__
#define	__16HSDI4AO4_UTILS_H__

#include "16hsdi4ao4_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	hsdi4ao4_close_util			(int fd, int index, int verbose);
int hsdi4ao4_init_util			(int verbose);
int hsdi4ao4_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	hsdi4ao4_open_util			(int device, int share, int index, int verbose, int* fd);
int	hsdi4ao4_read_util			(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got);
int	hsdi4ao4_write_util			(int fd, int index, int verbose, const void* src, size_t bytes, size_t* sent);

// IOCTL utility services

int	hsdi4ao4_ai_buf_clear		(int fd, int index, int verbose);								// HSDI4AO4_IOCTL_AI_BUF_CLEAR
int	hsdi4ao4_ai_buf_level		(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_AI_BUF_LEVEL
int	hsdi4ao4_ai_buf_overflow	(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AI_BUF_OVERFLOW
int	hsdi4ao4_ai_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AI_BUF_THR_LVL
int	hsdi4ao4_ai_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_AI_BUF_THR_STS
int	hsdi4ao4_ai_buf_underflow	(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AI_BUF_UNDERFLOW
int	hsdi4ao4_ai_burst_enable	(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AI_BURST_ENABLE
int	hsdi4ao4_ai_burst_size		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AI_BURST_SIZE
int	hsdi4ao4_ai_burst_status	(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_AI_BURST_STATUS
int	hsdi4ao4_ai_chan_sel		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AI_CHAN_SEL
int	hsdi4ao4_ai_clock_mode		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AI_CLOCK_MODE
int	hsdi4ao4_ai_enable			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AI_ENABLE
int	hsdi4ao4_ai_mode			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AI_MODE
int	hsdi4ao4_ai_range			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AI_RANGE
int	hsdi4ao4_ai_sw_clock		(int fd, int index, int verbose);								// HSDI4AO4_IOCTL_AI_SW_CLOCK
int	hsdi4ao4_ai_sw_trigger		(int fd, int index, int verbose);								// HSDI4AO4_IOCTL_AI_SW_TRIGGER
int	hsdi4ao4_ao_buf_clear		(int fd, int index, int verbose);								// HSDI4AO4_IOCTL_AO_BUF_CLEAR
int	hsdi4ao4_ao_buf_empty		(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_AO_BUF_EMPTY
int	hsdi4ao4_ao_buf_level		(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_AO_BUF_LEVEL
int	hsdi4ao4_ao_buf_load_req	(int fd, int index, int verbose);								// HSDI4AO4_IOCTL_AO_BUF_LOAD_REQ
int	hsdi4ao4_ao_buf_load_sts	(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_AO_BUF_LOAD_STS
int	hsdi4ao4_ao_buf_mode		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AO_BUF_MODE
int	hsdi4ao4_ao_buf_over_data	(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AO_BUF_OVER_DATA
int	hsdi4ao4_ao_buf_over_fram	(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AO_BUF_OVER_FRAM
int	hsdi4ao4_ao_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AO_BUF_THR_LVL
int	hsdi4ao4_ao_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_AO_BUF_THR_STS
int	hsdi4ao4_ao_burst_enable	(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AO_BURST_ENABLE
int	hsdi4ao4_ao_burst_status	(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_AO_BURST_STATUS
int	hsdi4ao4_ao_chan_sel		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AO_CHAN_SEL
int	hsdi4ao4_ao_clock_mode		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AO_CLOCK_MODE
int	hsdi4ao4_ao_clock_status	(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_AO_CLOCK_STATUS
int	hsdi4ao4_ao_enable			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AO_ENABLE
int	hsdi4ao4_ao_mode			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AO_MODE
int	hsdi4ao4_ao_output_mode		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AO_OUTPUT_MODE
int	hsdi4ao4_ao_range			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AO_RANGE
int	hsdi4ao4_ao_sw_clock		(int fd, int index, int verbose);								// HSDI4AO4_IOCTL_AO_SW_CLOCK
int	hsdi4ao4_ao_sw_trigger		(int fd, int index, int verbose);								// HSDI4AO4_IOCTL_AO_SW_TRIGGER
int	hsdi4ao4_ao_sync_mode		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_AO_SYNC_MODE
int	hsdi4ao4_autocal			(int fd, int index, int verbose);								// HSDI4AO4_IOCTL_AUTOCAL
int	hsdi4ao4_autocal_status		(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_AUTOCAL_STATUS
int	hsdi4ao4_data_format		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_DATA_FORMAT
int	hsdi4ao4_dio_dir_out		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_DIO_DIR_OUT
int	hsdi4ao4_dio_read			(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_DIO_READ
int	hsdi4ao4_dio_write			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_DIO_WRITE
int	hsdi4ao4_gen_a_enable		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_GEN_A_ENABLE
int	hsdi4ao4_gen_a_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_GEN_A_NDIV
int	hsdi4ao4_gen_a_nref			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_GEN_A_NREF
int	hsdi4ao4_gen_a_nvco			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_GEN_A_NVCO
int	hsdi4ao4_gen_b_enable		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_GEN_B_ENABLE
int	hsdi4ao4_gen_b_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_GEN_B_NDIV
int	hsdi4ao4_gen_c_enable		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_GEN_C_ENABLE
int	hsdi4ao4_gen_c_ndiv			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_GEN_C_NDIV
int	hsdi4ao4_initialize			(int fd, int index, int verbose);								// HSDI4AO4_IOCTL_INITIALIZE
int	hsdi4ao4_irq_enable			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_IRQ_ENABLE
int	hsdi4ao4_master_clock		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_MASTER_CLOCK
int	hsdi4ao4_master_clock_adj	(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_MASTER_CLOCK_ADJ
int	hsdi4ao4_query				(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_QUERY
int	hsdi4ao4_reg_mod			(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// HSDI4AO4_IOCTL_REG_MOD
int	hsdi4ao4_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// HSDI4AO4_IOCTL_REG_READ
int	hsdi4ao4_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// HSDI4AO4_IOCTL_REG_WRITE
int	hsdi4ao4_rx_io_abort		(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_RX_IO_ABORT
int	hsdi4ao4_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_RX_IO_MODE
int	hsdi4ao4_rx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_RX_IO_OVERFLOW
int	hsdi4ao4_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_RX_IO_TIMEOUT
int	hsdi4ao4_rx_io_underflow	(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_RX_IO_UNDERFLOW
int	hsdi4ao4_trigger_mode		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_TRIGGER_MODE
int	hsdi4ao4_tx_io_abort		(int fd, int index, int verbose, s32* get);						// HSDI4AO4_IOCTL_TX_IO_ABORT
int	hsdi4ao4_tx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_TX_IO_MODE
int	hsdi4ao4_tx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_TX_IO_OVERFLOW
int	hsdi4ao4_tx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// HSDI4AO4_IOCTL_TX_IO_TIMEOUT
int	hsdi4ao4_wait_cancel		(int fd, int index, int verbose, gsc_wait_t* wait);				// HSDI4AO4_IOCTL_WAIT_CANCEL
int	hsdi4ao4_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// HSDI4AO4_IOCTL_WAIT_EVENT
int	hsdi4ao4_wait_status		(int fd, int index, int verbose, gsc_wait_t* wait);				// HSDI4AO4_IOCTL_WAIT_STATUS

// Auxiliary utility services

int	hsdi4ao4_config_ai			(int fd, int index, int verbose, s32 fsamp, long master_clock);
int	hsdi4ao4_config_ao			(int fd, int index, int verbose, s32 fsamp, long master_clock);
int	hsdi4ao4_fsamp_ai_compute	(int fd, int index, int verbose, s32 fsamp, s32 low_noise, s32* ndiv, s32* nvco, s32* nref, double* rate);
int	hsdi4ao4_fsamp_ai_report	(int fd, int index, int verbose, int chan, s32* fsamp);
int	hsdi4ao4_fsamp_ai_report_all(int fd, int index, int verbose, s32* fsamp);
int	hsdi4ao4_fsamp_ao_compute	(int fd, int index, int verbose, s32 fsamp, s32* ndiv, double* rate);
int	hsdi4ao4_fsamp_ao_report	(int fd, int index, int verbose, int chan, s32* fsamp);
int	hsdi4ao4_fsamp_ao_report_all(int fd, int index, int verbose, s32* fsamp);
int	hsdi4ao4_id_device			(int fd, int index, int verbose);

int	hsdi4ao4_count_boards		(int verbose, s32* get);
int	hsdi4ao4_fsamp_ai_get		(int fd, int verbose, s32* get);
int	hsdi4ao4_fsamp_ao_get		(int fd, int verbose, s32* get);
int	hsdi4ao4_reg_list			(int fd, int detail);

const gsc_reg_def_t*			hsdi4ao4_reg_get_def_id			(u32 reg);
const gsc_reg_def_t*			hsdi4ao4_reg_get_def_index		(int index);
const char*						hsdi4ao4_reg_get_desc			(u32 reg);
const char*						hsdi4ao4_reg_get_name			(u32 reg);


// Retained for backwards compatibility only:
int	hsdi4ao4_auto_cal_sts		(int fd, int index, int verbose, s32* get);
int	hsdi4ao4_auto_calibrate		(int fd, int index, int verbose);



#endif
