// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/samples/aout/main.h $
// $Rev: 53434 $
// $Date: 2023-07-24 09:57:26 -0500 (Mon, 24 Jul 2023) $

// 16HSDI4AO4: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <limits.h>
#include <math.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "16hsdi4ao4_main.h"



// macros *********************************************************************

#define	D16						(0x10000)
#define	LOG_FILE				"log.txt"
#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	chan_qty;		// Generate output on # channels.
	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	empty_qty;		// Stop if the buffer runs empty # times (required -ml).
	s32	indefinate;		// Write data without limit until there is a problem.
	s32	index;			// device index
	s32	log_qty;		// Stop after logging # entries (requires -ml).
	s32	minute_limit;	// for continuous testing
	s32	minutes;		// Output data for this long.
	s32	monitor;		// Monitor and log timing and performance.
	int	qty;			// Number of devices detected.
	s32	reg_dump;		// When us_stop or empty_qty kick in, generate a register dump.
	s32	scan_limit;		// Limit output to # scans per write call
	s32	seconds;		// Output data for this long.
	s32	test_limit;		// for continuous testing
	s32	us_stop;		// Stop of write take # us or longer

	int	fd;				// File descriptor for device to access.

	// Device Settings

	s32	fsamp;
	s32	io_mode;
	s32	master_clock;
} args_t;



// prototypes *****************************************************************

FILE*	file_close(FILE* file);
FILE*	file_create(const char* name);
int		file_eof(FILE* file, int* eof);
FILE*	file_open(const char* name);
long	file_read_line(FILE* file, char* dst, size_t size);
int		file_seek(FILE* file, long pos, int wence);
long	file_tell(FILE* file);
long	file_write_str(FILE* file, const char* src);

int		perform_tests(const args_t* args);



#endif
