// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/samples/sbtest/ao_buf_thr_lvl.c $
// $Rev: 53428 $
// $Date: 2023-07-20 13:03:43 -0500 (Thu, 20 Jul 2023) $

// 16HSDI4AO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0,
			/* reg		*/	HSDI4AO4_GSC_OBTR,
			/* mask		*/	0x7FFFF,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;
	int	i;

	errs	+= hsdi4ao4_initialize(fd, -1, 0);

	for (i = 0; i <= 18; i++)
	{
		// Walking one.
		list[0].arg		= (1L << i) & 0x7FFFF;
		list[0].value	= list[0].arg;
		errs			+= service_ioctl_set_reg_list(fd, __LINE__, list);
		errs			+= service_ioctl_reg_get_list(fd, __LINE__, list);

		// Walking zero.
		list[0].arg		= ~(1L << i) & 0x7FFFF;
		list[0].value	= list[0].arg;
		errs			+= service_ioctl_set_reg_list(fd, __LINE__, list);
		errs			+= service_ioctl_reg_get_list(fd, __LINE__, list);
	}

	errs	+= hsdi4ao4_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	int	errs	= 0;

	return(errs);
}



/******************************************************************************
*
*	Function:	ao_buf_thr_lvl_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSDI4AO4_IOCTL_AO_BUF_THR_LVL.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ao_buf_thr_lvl_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSDI4AO4_IOCTL_AO_BUF_THR_LVL");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


