// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/samples/sbtest/ao_chan_sel.c $
// $Rev: 53428 $
// $Date: 2023-07-20 13:03:43 -0500 (Thu, 20 Jul 2023) $

// 16HSDI4AO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_AO_CHAN_SEL,
			/* arg		*/	0,
			/* reg		*/	HSDI4AO4_GSC_BOOR,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	i;
	u32	mask[5]	= { 0x0, 0x1, 0x3, 0x7, 0xF };
	s32	qty		= 0;

	errs	+= hsdi4ao4_initialize(fd, -1, 0);

	errs			+= hsdi4ao4_query(fd, -1, 0, HSDI4AO4_QUERY_CHANNEL_AI_QTY, &qty);
	list[0].mask	= mask[qty];

	for (i = 0; i < qty; i++)
	{
		// Walking one.
		list[0].arg		= 0x1UL << i;
		list[0].value	= list[0].arg;
		errs			+= service_ioctl_set_reg_list(fd, __LINE__, list);
		errs			+= service_ioctl_reg_get_list(fd, __LINE__, list);

		// Walking zero.
		list[0].arg		= (~0x1UL << i) & mask[qty];
		list[0].value	= list[0].arg;
		errs			+= service_ioctl_set_reg_list(fd, __LINE__, list);
		errs			+= service_ioctl_reg_get_list(fd, __LINE__, list);
	}

	errs	+= hsdi4ao4_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This requires additional equipment to verify.
	return(0);
}



/******************************************************************************
*
*	Function:	ao_chan_sel_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSDI4AO4_IOCTL_AO_CHAN_SEL.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ao_chan_sel_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSDI4AO4_IOCTL_AO_CHAN_SEL");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


