// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/samples/sbtest/autocal_status.c $
// $Rev: 53428 $
// $Date: 2023-07-20 13:03:43 -0500 (Thu, 20 Jul 2023) $

// 16HSDI4AO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// There are no persistant bits to test.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_AUTOCAL,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	ret;
	s32	sts		= 0;

	errs	+= hsdi4ao4_initialize(fd, -1, 0);

	ret		= hsdi4ao4_ioctl(fd, HSDI4AO4_IOCTL_AUTOCAL_STATUS, &sts);
	errs	+= ret ? 1 : 0;

	if ((errs == 0) && (sts != HSDI4AO4_AUTOCAL_STATUS_PASS))
	{
		errs++;
		printf("FAIL <---  (%d. status != PASS)\n", __LINE__);
	}

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);

	ret		= hsdi4ao4_ioctl(fd, HSDI4AO4_IOCTL_AUTOCAL_STATUS, &sts);
	errs	+= ret ? 1 : 0;

	if ((errs == 0) && (sts != HSDI4AO4_AUTOCAL_STATUS_PASS))
	{
		errs++;
		printf("FAIL <---  (%d. status != PASS)\n", __LINE__);
	}

	errs	+= hsdi4ao4_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	autocal_status_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSDI4AO4_IOCTL_AUTOCAL_STATUS.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int autocal_status_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSDI4AO4_IOCTL_AUTOCAL_STATUS");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


