// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/samples/sbtest/dio_dir_out.c $
// $Rev: 53428 $
// $Date: 2023-07-20 13:03:43 -0500 (Thu, 20 Jul 2023) $

// 16HSDI4AO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_DIO_DIR_OUT,
			/* arg		*/	HSDI4AO4_DIO_DIR_OUT_B0_IN_B1_IN,
			/* reg		*/	HSDI4AO4_GSC_DIOPR,
			/* mask		*/	0x01000100,
			/* value	*/	0x00000000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_DIO_DIR_OUT,
			/* arg		*/	HSDI4AO4_DIO_DIR_OUT_B0_OT_B1_IN,
			/* reg		*/	HSDI4AO4_GSC_DIOPR,
			/* mask		*/	0x01000100,
			/* value	*/	0x00000100
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_DIO_DIR_OUT,
			/* arg		*/	HSDI4AO4_DIO_DIR_OUT_B0_IN_B1_OT,
			/* reg		*/	HSDI4AO4_GSC_DIOPR,
			/* mask		*/	0x01000100,
			/* value	*/	0x01000000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_DIO_DIR_OUT,
			/* arg		*/	HSDI4AO4_DIO_DIR_OUT_B0_OT_B1_OT,
			/* reg		*/	HSDI4AO4_GSC_DIOPR,
			/* mask		*/	0x01000100,
			/* value	*/	0x01000100
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= hsdi4ao4_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
	errs	+= service_ioctl_reg_get_list(fd, __LINE__, list);

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
	errs	+= service_ioctl_reg_get_list(fd, __LINE__, list);

	errs	+= hsdi4ao4_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This requires additional equipment to test.
	return(0);
}



/******************************************************************************
*
*	Function:	dio_dir_out_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSDI4AO4_IOCTL_DIO_DIR_OUT.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dio_dir_out_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSDI4AO4_IOCTL_DIO_DIR_OUT");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


