// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/samples/sbtest/dio_write.c $
// $Rev: 53428 $
// $Date: 2023-07-20 13:03:43 -0500 (Thu, 20 Jul 2023) $

// 16HSDI4AO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_DIO_DIR_OUT,
			/* arg		*/	HSDI4AO4_DIO_DIR_OUT_B0_OT_B1_OT,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_DIO_WRITE,
			/* arg		*/	0,
			/* reg		*/	HSDI4AO4_GSC_DIOPR,
			/* mask		*/	0x00FF00FF,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	i;
	s32	set;

	for (i = 0; i < 16; i++)
	{
		errs	+= hsdi4ao4_initialize(fd, -1, 0);

		// Walking one.
		set				= 1 << i;
		list[1].arg		= set;
		list[1].value	= (set & 0xFF) | ((set & 0xFF00) << 8);
		errs			+= service_ioctl_set_reg_list(fd, __LINE__, list);

		// walking zero.
		set				= 0xFFFF ^ (1 << i);
		list[1].arg		= set;
		list[1].value	= (set & 0xFF) | ((set & 0xFF00) << 8);
		errs			+= service_ioctl_set_reg_list(fd, __LINE__, list);

		errs	+= hsdi4ao4_initialize(fd, -1, 0);
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This test is the same as the service test.
	return(0);
}



/******************************************************************************
*
*	Function:	dio_write_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSDI4AO4_IOCTL_DIO_WRITE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dio_write_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSDI4AO4_IOCTL_DIO_WRITE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


