// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/samples/sbtest/irq_enable.c $
// $Rev: 53428 $
// $Date: 2023-07-20 13:03:43 -0500 (Thu, 20 Jul 2023) $

// 16HSDI4AO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_IRQ_ENABLE,
			/* arg		*/	0,
			/* reg		*/	HSDI4AO4_GSC_PSR,
			/* mask		*/	0x7FFF,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	i;
	s32	set;

	for (i = 0; i <= 14; i++)
	{
		errs	+= hsdi4ao4_initialize(fd, -1, 0);

		// Walking one
		set				= 1L << i;
		list[0].arg		= set;
		list[0].value	= list[0].arg;

		errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
		errs	+= service_ioctl_reg_get_list(fd, __LINE__, list);

		errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
		errs	+= service_ioctl_reg_get_list(fd, __LINE__, list);

		// Walking zero.
		set				= 0x7FFF ^ (1L << i);
		list[0].arg		= set;
		list[0].value	= list[0].arg;

		errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
		errs	+= service_ioctl_reg_get_list(fd, __LINE__, list);

		errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
		errs	+= service_ioctl_reg_get_list(fd, __LINE__, list);

		errs	+= hsdi4ao4_initialize(fd, -1, 0);
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// These are tested in the WAIT EVENT IOCTL test code.
	return(0);
}



/******************************************************************************
*
*	Function:	irq_enable_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSDI4AO4_IOCTL_IRQ_ENABLE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int irq_enable_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSDI4AO4_IOCTL_IRQ_ENABLE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


