// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/samples/sbtest/master_clock.c $
// $Rev: 53428 $
// $Date: 2023-07-20 13:03:43 -0500 (Thu, 20 Jul 2023) $

// 16HSDI4AO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_MASTER_CLOCK,
			/* arg		*/	0,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int		errs	= 0;
	long	l;
	s32		ref;

	errs	+=  hsdi4ao4_query(fd, -1, 0, HSDI4AO4_QUERY_MASTER_CLOCK_DEF, & ref);

	for (	l = HSDI4AO4_MASTER_CLOCK_MIN;
			l <= HSDI4AO4_MASTER_CLOCK_MAX;
			l += 1000)
	{
		errs		+= hsdi4ao4_initialize(fd, -1, 0);
		list[0].arg	= l;
		errs		+= service_ioctl_set_get_list(fd, __LINE__, list);
		errs		+= hsdi4ao4_initialize(fd, -1, 0);
	}

	list[0].arg	= ref;
	errs		+= service_ioctl_set_get_list(fd, __LINE__, list);
	errs		+= hsdi4ao4_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This requires additional equipment to verify.
	return(0);
}



/******************************************************************************
*
*	Function:	master_clock_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSDI4AO4_IOCTL_MASTER_CLOCK.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int master_clock_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSDI4AO4_IOCTL_MASTER_CLOCK");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


