// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/samples/sbtest/main.c $
// $Rev: 49718 $
// $Date: 2021-10-01 17:10:46 -0500 (Fri, 01 Oct 2021) $

// 16HSDI4AO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	errs	+= reg_read_test(args->fd);			// HSDI4AO4_IOCTL_REG_READ
	errs	+= reg_write_test(args->fd);		// HSDI4AO4_IOCTL_REG_WRITE
	errs	+= reg_mod_test(args->fd);			// HSDI4AO4_IOCTL_REG_MOD
	errs	+= query_test(args->fd);			// HSDI4AO4_IOCTL_QUERY
	errs	+= initialize_test(args->fd);		// HSDI4AO4_IOCTL_INITIALIZE
	errs	+= autocal_test(args->fd);			// HSDI4AO4_IOCTL_AUTOCAL
	errs	+= autocal_status_test(args->fd);	// HSDI4AO4_IOCTL_AUTOCAL_STATUS

	errs	+= rx_io_abort_test(args->fd);		// HSDI4AO4_IOCTL_RX_IO_ABORT
	errs	+= rx_io_mode_test(args->fd);		// HSDI4AO4_IOCTL_RX_IO_MODE
	errs	+= rx_io_overflow_test(args->fd);	// HSDI4AO4_IOCTL_RX_IO_OVERFLOW
	errs	+= rx_io_timeout_test(args->fd);	// HSDI4AO4_IOCTL_RX_IO_TIMEOUT
	errs	+= rx_io_underflow_test(args->fd);	// HSDI4AO4_IOCTL_RX_IO_UNDERFLOW

	errs	+= tx_io_abort_test(args->fd);		// HSDI4AO4_IOCTL_TX_IO_ABORT
	errs	+= tx_io_mode_test(args->fd);		// HSDI4AO4_IOCTL_TX_IO_MODE
	errs	+= tx_io_overflow_test(args->fd);	// HSDI4AO4_IOCTL_TX_IO_OVERFLOW
	errs	+= tx_io_timeout_test(args->fd);	// HSDI4AO4_IOCTL_TX_IO_TIMEOUT

	errs	+= ai_buf_clear_test(args->fd);		// HSDI4AO4_IOCTL_AI_BUF_CLEAR
	errs	+= ai_buf_level_test(args->fd);		// HSDI4AO4_IOCTL_AI_BUF_LEVEL
	errs	+= ai_buf_overflow_test(args->fd);	// HSDI4AO4_IOCTL_AI_BUF_OVERFLOW
	errs	+= ai_buf_thr_lvl_test(args->fd);	// HSDI4AO4_IOCTL_AI_BUF_THR_LVL
	errs	+= ai_buf_thr_sts_test(args->fd);	// HSDI4AO4_IOCTL_AI_BUF_THR_STS
	errs	+= ai_buf_underflow_test(args->fd);	// HSDI4AO4_IOCTL_AI_BUF_UNDERFLOW
	errs	+= ai_burst_enable_test(args->fd);	// HSDI4AO4_IOCTL_AI_BURST_ENABLE
	errs	+= ai_burst_size_test(args->fd);	// HSDI4AO4_IOCTL_AI_BURST_SIZE
	errs	+= ai_burst_status_test(args->fd);	// HSDI4AO4_IOCTL_AI_BURST_STATUS
	errs	+= ai_chan_sel_test(args->fd);		// HSDI4AO4_IOCTL_AI_CHAN_SEL
	errs	+= ai_clock_mode_test(args->fd);	// HSDI4AO4_IOCTL_AI_CLOCK_MODE
	errs	+= ai_enable_test(args->fd);		// HSDI4AO4_IOCTL_AI_ENABLE
	errs	+= ai_mode_test(args->fd);			// HSDI4AO4_IOCTL_AI_MODE
	errs	+= ai_range_test(args->fd);			// HSDI4AO4_IOCTL_AI_RANGE
	errs	+= ai_sw_clock_test(args->fd);		// HSDI4AO4_IOCTL_AI_SW_CLOCK
	errs	+= ai_sw_trigger_test(args->fd);	// HSDI4AO4_IOCTL_AI_SW_TRIGGER

	errs	+= ao_buf_clear_test(args->fd);		// HSDI4AO4_IOCTL_AO_BUF_CLEAR
	errs	+= ao_buf_empty_test(args->fd);		// HSDI4AO4_IOCTL_AO_BUF_EMPTY
	errs	+= ao_buf_level_test(args->fd);		// HSDI4AO4_IOCTL_AO_BUF_LEVEL
	errs	+= ao_buf_load_req_test(args->fd);	// HSDI4AO4_IOCTL_AO_BUF_LOAD_REQ
	errs	+= ao_buf_load_sts_test(args->fd);	// HSDI4AO4_IOCTL_AO_BUF_LOAD_STS
	errs	+= ao_buf_mode_test(args->fd);		// HSDI4AO4_IOCTL_AO_BUF_MODE
	errs	+= ao_buf_over_data_test(args->fd);	// HSDI4AO4_IOCTL_AO_BUF_OVER_DATA
	errs	+= ao_buf_over_fram_test(args->fd);	// HSDI4AO4_IOCTL_AO_BUF_OVER_FRAM
	errs	+= ao_buf_thr_lvl_test(args->fd);	// HSDI4AO4_IOCTL_AO_BUF_THR_LVL
	errs	+= ao_buf_thr_sts_test(args->fd);	// HSDI4AO4_IOCTL_AO_BUF_THR_STS
	errs	+= ao_burst_enable_test(args->fd);	// HSDI4AO4_IOCTL_AO_BURST_ENABLE
	errs	+= ao_burst_status_test(args->fd);	// HSDI4AO4_IOCTL_AO_BURST_STATUS
	errs	+= ao_chan_sel_test(args->fd);		// HSDI4AO4_IOCTL_AO_CHAN_SEL
	errs	+= ao_clock_mode_test(args->fd);	// HSDI4AO4_IOCTL_AO_CLOCK_MODE
	errs	+= ao_clock_status_test(args->fd);	// HSDI4AO4_IOCTL_AO_CLOCK_STATUS
	errs	+= ao_enable_test(args->fd);		// HSDI4AO4_IOCTL_AO_ENABLE
	errs	+= ao_mode_test(args->fd);			// HSDI4AO4_IOCTL_AO_MODE
	errs	+= ao_output_mode_test(args->fd);	// HSDI4AO4_IOCTL_AO_OUTPUT_MODE
	errs	+= ao_range_test(args->fd);			// HSDI4AO4_IOCTL_AO_RANGE
	errs	+= ao_sw_clock_test(args->fd);		// HSDI4AO4_IOCTL_AO_SW_CLOCK
	errs	+= ao_sw_trigger_test(args->fd);	// HSDI4AO4_IOCTL_AO_SW_TRIGGER
	errs	+= ao_sync_mode_test(args->fd);		// HSDI4AO4_IOCTL_AO_SYNC_MODE

	errs	+= data_format_test(args->fd);		// HSDI4AO4_IOCTL_DATA_FORMAT
	errs	+= dio_dir_out_test(args->fd);		// HSDI4AO4_IOCTL_DIO_DIR_OUT
	errs	+= dio_read_test(args->fd);			// HSDI4AO4_IOCTL_DIO_READ
	errs	+= dio_write_test(args->fd);		// HSDI4AO4_IOCTL_DIO_WRITE
	errs	+= gen_a_enable_test(args->fd);		// HSDI4AO4_IOCTL_GEN_A_ENABLE
	errs	+= gen_a_ndiv_test(args->fd);		// HSDI4AO4_IOCTL_GEN_A_NDIV
	errs	+= gen_a_nref_test(args->fd);		// HSDI4AO4_IOCTL_GEN_A_NREF
	errs	+= gen_a_nvco_test(args->fd);		// HSDI4AO4_IOCTL_GEN_A_NVCO
	errs	+= gen_b_enable_test(args->fd);		// HSDI4AO4_IOCTL_GEN_B_ENABLE
	errs	+= gen_b_ndiv_test(args->fd);		// HSDI4AO4_IOCTL_GEN_B_NDIV
	errs	+= gen_c_enable_test(args->fd);		// HSDI4AO4_IOCTL_GEN_C_ENABLE
	errs	+= gen_c_ndiv_test(args->fd);		// HSDI4AO4_IOCTL_GEN_C_NDIV
	errs	+= irq_enable_test(args->fd);		// HSDI4AO4_IOCTL_IRQ_ENABLE
	errs	+= master_clock_test(args->fd);		// HSDI4AO4_IOCTL_MASTER_CLOCK
	errs	+= master_clock_adj_test(args->fd);	// HSDI4AO4_IOCTL_MASTER_CLOCK_ADJ
	errs	+= trigger_mode_test(args->fd);		// HSDI4AO4_IOCTL_TRIGGER_MODE
	errs	+= wait_event_test(args->fd);		// HSDI4AO4_IOCTL_WAIT_EVENT
	errs	+= wait_cancel_test(args->fd);		// HSDI4AO4_IOCTL_WAIT_CANCEL
	errs	+= wait_status_test(args->fd);		// HSDI4AO4_IOCTL_WAIT_STATUS

	return(errs);
}


