// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/samples/sbtest/tx_io_overflow.c $
// $Rev: 53428 $
// $Date: 2023-07-20 13:03:43 -0500 (Thu, 20 Jul 2023) $

// 16HSDI4AO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_TX_IO_OVERFLOW,
			/* arg		*/	HSDI4AO4_IO_OVERFLOW_IGNORE,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_TX_IO_OVERFLOW,
			/* arg		*/	HSDI4AO4_IO_OVERFLOW_CHECK,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= hsdi4ao4_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_get_list(fd, __LINE__, list);
	errs	+= service_ioctl_set_get_list(fd, __LINE__, list);
	errs	+= hsdi4ao4_initialize(fd, -1, 0);

	return(errs);
}



//*****************************************************************************
static int _tx_fifo_fill(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_AO_MODE,
			/* arg		*/	HSDI4AO4_AO_MODE_FIFO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_AO_ENABLE,
			/* arg		*/	HSDI4AO4_AIO_ENABLE_NO,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_REG_WRITE,
			/* cmd		*/	0,
			/* arg		*/	1024,
			/* reg		*/	HSDI4AO4_GSC_AOBR,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	u32	boor;
	int	errs	= 0;
	int	i;

	for (i = 0; i < 1024; i++)
	{
		errs	+= service_ioctl_set_list(fd, __LINE__, list);
		errs	+= hsdi4ao4_reg_read(fd, -1, 0, HSDI4AO4_GSC_BOOR, &boor);

		if (boor & 0x8000)
		{
			// The Tx FIFO is FULL.
			break;
		}
		else
		{
			// The Output Buffer is not FULL
			continue;
		}
	}

	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_REG_WRITE,
			/* cmd		*/	0,
			/* arg		*/	1024,
			/* reg		*/	HSDI4AO4_GSC_AOBR,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_AO_ENABLE,
			/* arg		*/	HSDI4AO4_AIO_ENABLE_YES,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_GEN_C_ENABLE,
			/* arg		*/	HSDI4AO4_GEN_ENABLE_YES,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_SLEEP_MS,
			/* cmd		*/	0,
			/* arg		*/	50,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	ignore[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_TX_IO_OVERFLOW,
			/* arg		*/	HSDI4AO4_IO_OVERFLOW_IGNORE,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	check[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_TX_IO_OVERFLOW,
			/* arg		*/	HSDI4AO4_IO_OVERFLOW_CHECK,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static const service_data_t	clear[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	HSDI4AO4_IOCTL_AO_BUF_OVER_DATA,
			/* arg		*/	HSDI4AO4_BUF_OVERFLOW_CLEAR,
			/* reg		*/	-1,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	char	buf[4]	= { 0 };
	int		errs	= 0;
	long	ret;

	errs	+= hsdi4ao4_initialize(fd, -1, 0);

	errs	+= _tx_fifo_fill(fd);							// Fill the Tx FIFO.
	errs	+= service_ioctl_set_list(fd, __LINE__, list);	// Overflow the Tx buffer.
	errs	+= service_ioctl_set_list(fd, __LINE__, ignore);// Ignore overflows
	ret		= hsdi4ao4_write(fd, buf, 4);

	if ((errs == 0) && (ret != 4))
	{
		errs++;
		printf("FAIL <---  (%d. overflow was not ignored)\n", __LINE__);
	}

	// Check overflows
	errs	+= service_ioctl_set_list(fd, __LINE__, check);

	ret	= hsdi4ao4_write(fd, buf, 4);

	if ((errs == 0) && (ret >= 0))
	{
		errs++;
		printf("FAIL <---  (%d. overflow was ignored)\n", __LINE__);
	}

	// Clear the overflow and check again.
	errs	+= service_ioctl_set_list(fd, __LINE__, clear);

	ret	= hsdi4ao4_write(fd, buf, 4);

	if ((errs == 0) && (ret != 4))
	{
		errs++;
		printf("FAIL <---  (%d. overflow was observed)\n", __LINE__);
	}

	errs	+= hsdi4ao4_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	tx_io_overflow_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service HSDI4AO4_IOCTL_TX_IO_OVERFLOW.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int tx_io_overflow_test(int fd)
{
	int	errs	= 0;

	gsc_label("HSDI4AO4_IOCTL_TX_IO_OVERFLOW");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


