// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/utils/util_ai_sw_trigger.c $
// $Rev: 52566 $
// $Date: 2023-03-08 09:41:05 -0600 (Wed, 08 Mar 2023) $

// 16HSDI4AO4: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	hsdi4ao4_ai_sw_trigger
*
*	Purpose:
*
*		Provide a visual wrapper for the HSDI4AO4_IOCTL_AI_SW_TRIGGER service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	hsdi4ao4_ai_sw_trigger(int fd, int index, int verbose)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("AI SW Trigger", index);

	ret		= hsdi4ao4_ioctl(fd, HSDI4AO4_IOCTL_AI_SW_TRIGGER, NULL);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	return(errs);
}


