// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/utils/util_ao_buf_empty.c $
// $Rev: 52566 $
// $Date: 2023-03-08 09:41:05 -0600 (Wed, 08 Mar 2023) $

// 16HSDI4AO4: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	hsdi4ao4_ao_buf_empty
*
*	Purpose:
*
*		Provide a visual wrapper for the HSDI4AO4_IOCTL_AO_BUF_EMPTY service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		Report the status here.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	hsdi4ao4_ao_buf_empty(int fd, int index, int verbose, s32* get)
{
	int	errs;
	int	ret;
	s32	set;

	if (verbose)
		gsc_label_index("AO Buffer Empty", index);

	ret		= hsdi4ao4_ioctl(fd, HSDI4AO4_IOCTL_AO_BUF_EMPTY, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", set ? "Yes" : "No");

	if (get)
		get[0]	= set;

	return(errs);
}


