// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16HSDI4AO4/utils/util_master_clock.c $
// $Rev: 52967 $
// $Date: 2023-05-02 14:02:08 -0500 (Tue, 02 May 2023) $

// 16HSDI4AO4: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	hsdi4ao4_master_clock
*
*	Purpose:
*
*		Provide a visual wrapper for the HSDI4AO4_IOCTL_MASTER_CLOCK service.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the device to access. Ignore if < 0.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
******************************************************************************/

int	hsdi4ao4_master_clock(int fd, int index, int verbose, s32 set, s32* get)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Master Clock", index);

	ret		= hsdi4ao4_ioctl(fd, HSDI4AO4_IOCTL_MASTER_CLOCK, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		printf("%s  (", errs ? "FAIL <---" : "PASS");
		gsc_label_long_comma((long) set);
		printf(" Hz)\n");
	}

	if (get)
		get[0]	= set;

	return(errs);
}


